//---------------------------------------------------------------------------

#include <vcl.h>
#include <iterator>
#include "algostuff.hpp"

#include <conio.h> //  getch()

#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused
using namespace std;

std::string ToRus(const std::string &in)
{
  char *buff = new char [in.length()+1];
  CharToOem(in.c_str(),buff);
  std::string out(buff);
  delete [] buff;
  return out;
}

int main()
{
  vector<int> coll;

  INSERT_ELEMENTS(coll,1,9);
  PRINT_ELEMENTS(coll," :\n");

  //   
  cout << ToRus(" : ")
       << accumulate (coll.begin(), coll.end(),    // 
                      0)                           //  
       << endl;

  //      100
  cout << ToRus("     100: ")
       << accumulate (coll.begin(), coll.end(),    // 
                      -100)                        //  
       << endl;

  //   
  cout << ToRus(" : ")
       << accumulate (coll.begin(), coll.end(),    // 
                      1,                           //  
                      multiplies<int>())           // 
       << endl;

    //    (   0)
  cout << ToRus(" \n(   0): ")
       << accumulate (coll.begin(), coll.end(),    // 
                      0,                           //  
                      multiplies<int>())           // 
       << endl;


  getch();
  return 0;
}

//---------------------------------------------------------------------------